#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from cblog.templates.SiteTemplate import SiteTemplate

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0rc7'
__CHEETAH_versionTuple__ = (2, 0, 0, 'candidate', 7)
__CHEETAH_genTime__ = 1165587713.923543
__CHEETAH_genTimestamp__ = 'Fri Dec  8 15:21:53 2006'
__CHEETAH_src__ = 'archive.tmpl'
__CHEETAH_srcLastModified__ = 'Fri Dec  8 14:43:19 2006'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class archive(SiteTemplate):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        SiteTemplate.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def pagetitle(self, **KWS):



        ## CHEETAH: generated from #def pagetitle at line 7, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('  <title>')
        _v = VFFSL(SL,"tg.blogtitle",False) # '${tg.blogtitle}' on line 8, col 10
        if _v is not None: write(_filter(_v, rawExpr='${tg.blogtitle}')) # from line 8, col 10.
        write(': Archive</title>\n')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def pagecontent(self, **KWS):



        ## CHEETAH: generated from #def pagecontent at line 11, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('<h1>Archive</h1>\n\n<p class="firstpar">This is the archive of the blog <em>')
        _v = VFFSL(SL,"tg.blogtitle",False) # '${tg.blogtitle}' on line 14, col 57
        if _v is not None: write(_filter(_v, rawExpr='${tg.blogtitle}')) # from line 14, col 57.
        write('</em>. This blog currently has <strong>')
        _v = VFFSL(SL,"numentries",False) # '${numentries}' on line 14, col 111
        if _v is not None: write(_filter(_v, rawExpr='${numentries}')) # from line 14, col 111.
        write(' post')
        if VFFSL(SL,"numentries",False) != 1: # generated from line 14, col 129
            write('s')
        write('</strong> with <strong>')
        _v = VFFSL(SL,"numcomments",False) # '${numcomments}' on line 14, col 182
        if _v is not None: write(_filter(_v, rawExpr='${numcomments}')) # from line 14, col 182.
        write(' comment')
        if VFFSL(SL,"numcomments",False) != 1: # generated from line 14, col 204
            write('s')
        write('</strong>, sorted into <strong>')
        _v = VFFSL(SL,"numtags",False) # '${numtags}' on line 14, col 266
        if _v is not None: write(_filter(_v, rawExpr='${numtags}')) # from line 14, col 266.
        write(' categor')
        if VFFSL(SL,"numtags",False) == 1: # generated from line 14, col 284
            write('y')
        else: # generated from line 14, col 303
            write('ies')
        write('</strong> (tag')
        if VFFSL(SL,"numtags",False) != 1: # generated from line 14, col 334
            write('s')
        write(''').</p>

Through the links on the sidebar, you will be able to browse through the archived posts by month or category. If you are looking for a specific post or comment, you can also use the input box at the top of the sidebar to search through the archives by post title or do a full-text search covering posts, comments and author names.<p>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''


''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_archive= 'writeBody'

## END CLASS DEFINITION

if not hasattr(archive, '_initCheetahAttributes'):
    templateAPIClass = getattr(archive, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(archive)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=archive()).run()


